#include "stdafx.h"
#include <stdlib.h>
#include "int96.h"
#ifdef __GNUC__
#include "time.h"
#endif

int main()
{
  CInt96 z, q;
  CInt96 w(0x10101);
  CInt96 y;
  int i, j;

  srand(time(NULL));

  //Try out the FormatAsDecimal function using a value starting with "10".
  CInt96 u;
  #ifndef __GNUC__
  u.ConvertFromDecimalString(_T("106686720"));
  CString sText = u.FormatAsDecimal();
  #endif

  CInt96 xbig(1);
  xbig <<= 95;
  xbig = ~xbig;
  #ifndef __GNUC__
  CString sBig = xbig.FormatAsDecimal();
  #endif

  //Try out the display functions
  CInt96 hh;
  #ifndef __GNUC__
  CString sDisplay = hh.FormatAsBinary(TRUE);
  sDisplay = hh.FormatAsBinary(FALSE);
  sDisplay = hh.FormatAsHex(TRUE);
  sDisplay = hh.FormatAsHex(FALSE);
  sDisplay = hh.FormatAsDecimal();

  hh = CInt96(0x12345678987654);
  sDisplay = hh.FormatAsBinary(TRUE);
  sDisplay = hh.FormatAsBinary(FALSE);
  sDisplay = hh.FormatAsHex(TRUE);
  sDisplay = hh.FormatAsHex(FALSE);
  sDisplay = hh.FormatAsDecimal();
  hh.Negate();
  sDisplay = hh.FormatAsDecimal();

  CInt96 g;
  BOOL bSuccess = g.ConvertFromBinaryString(_T("  0110100101010110101  "));
  bSuccess = g.ConvertFromHexString(_T("  abcdef12345678fecaABCD  "));
  bSuccess = g.ConvertFromDecimalString(_T(" - 1234567"));
  g.Negate();
  bSuccess = g.ConvertFromDecimalString(_T("  1234567  "));
  bSuccess = g.ConvertFromBinaryString(_T(""));
  bSuccess = g.ConvertFromHexString(_T(""));
  bSuccess = g.ConvertFromDecimalString(_T(""));
  #endif


  //Test the division functions
  int xx = 55 / -2;
  int yy = 55 % -2;

  xx = 55 / -1;
  yy = 55 % -1;

  xx = 55 / 4;
  yy = 55 % 4;

  xx = -55 / -2;
  yy = -55 % -2;

  xx = -55 / -1;
  yy = -55 % -1;

  xx = 55 / 4;
  yy = 55 % 4;

  CInt96 a(55);
  CInt96 Quotient;
  CInt96 Remainder;
  a.Modulus(CInt96(2), Quotient, Remainder);
  a.Modulus(CInt96(1), Quotient, Remainder);
  a.Modulus(CInt96(4), Quotient, Remainder);

  Remainder = a % CInt96(4);
  Quotient = a / CInt96(4);

  a.Modulus(CInt96(-2), Quotient, Remainder);
  Quotient.Negate();
  a.Modulus(CInt96(-1), Quotient, Remainder);
  Quotient.Negate();
  a.Modulus(CInt96(-4), Quotient, Remainder);
  Quotient.Negate();

  //a.Modulus(CInt96(0), Quotient, Remainder);
  a = CInt96(0);
  a.Modulus(CInt96(2), Quotient, Remainder);
  a.Modulus(CInt96(1), Quotient, Remainder);
  a.Modulus(CInt96(4), Quotient, Remainder);
  //a.Modulus(CInt96(0), Quotient, Remainder); //should cause a devide by 0 exception

  a = CInt96(-61);
  a.Modulus(CInt96(2), Quotient, Remainder);
  Quotient.Negate();
  a.Modulus(CInt96(1), Quotient, Remainder);
  Quotient.Negate();
  a.Modulus(CInt96(4), Quotient, Remainder);
  Quotient.Negate();
  a.Modulus(CInt96(-2), Quotient, Remainder);
  a.Modulus(CInt96(-1), Quotient, Remainder);
  a.Modulus(CInt96(-4), Quotient, Remainder);


  //Try the operator<< function
  #ifndef __GNUC__
  TRACE(_T("w is %s"), w.FormatAsBinary());
  #endif

  for (j=0; j<96; j++)
  {
    q = w << j;

    #ifndef __GNUC__
    TRACE(_T("\nq << %02d is %s"), j, q.FormatAsBinary());
    #endif

    if (j == 76)
      y = q;
  }


  //Try the operator>> function
  #ifndef __GNUC__
  TRACE(_T("\n\ny is       %s"), y.FormatAsBinary());
  #endif

  for (j=0; j<96; j++)
  {
    q = y >> j;

    #ifndef __GNUC__
    TRACE(_T("\nq >> %02d is %s"), j, q.FormatAsBinary());
    #endif
  }


  //Test the addition functions
  z = CInt96(3) + CInt96(14);
  z = CInt96(3) + CInt96(-14);
  z.Negate();
  z = CInt96(-3) + CInt96(14);
  z.Negate();
  z = CInt96(-3) + CInt96(-14);
  z.Negate();


  //Try the subtraction functions
  z = CInt96(3) - CInt96(14);
  z.Negate();
  z = CInt96(3) - CInt96(-14);
  z = CInt96(-3) - CInt96(14);
  z.Negate();
  z = CInt96(-3) - CInt96(-14);

  z = CInt96(0) - CInt96(1);
  z = -z;  
  z = CInt96(0) - CInt96(-1);


  //Test the multiplication functions
  z = CInt96(0xFFFF) * CInt96(0x1ef04);

  #ifndef __GNUC__
  TRACE(_T("\nz = %s"), z.FormatAsBinary());
  #endif

  z = CInt96(3) * CInt96(14);
  z = CInt96(-3) * CInt96(14);
  z.Negate();
  z = CInt96(-3) * CInt96(-14);
  z = CInt96(3) * CInt96(-14);
  z.Negate();


  //Test the bug discovered in CInt96 v1.03
  CInt96 mula;
  #ifndef __GNUC__
  mula.ConvertFromDecimalString(_T("1387233076032"));
  #endif
  CInt96 mulb;
  #ifndef __GNUC__
  mulb.ConvertFromDecimalString(_T("1000000000"));
  #endif
  z = mula * mulb;
  #ifndef __GNUC__
  sText = z.FormatAsDecimal();
  #endif
  z = mulb * mula;
  #ifndef __GNUC__
  sText = z.FormatAsDecimal();
  #endif


  //Do some speed tests on addition
  #ifndef __GNUC__
  DWORD dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    i64 x = ((i64)rand()) + ((i64)rand());
    x; //To get rid of unused variable warning
  }
  #ifndef __GNUC__
  DWORD dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for addition of __int64's was %d ms\n"), dwTimeTaken);
  #endif

  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    CInt96 x = CInt96(rand()) + CInt96(rand());
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for addition of CInt96's was %d ms\n"), dwTimeTaken);
  #endif


  //Do some speed tests on subtraction
  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    i64 x = ((i64)rand()) - ((i64)rand());
    x; //To get rid of unused variable warning
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for subtraction of __int64's was %d ms\n"), dwTimeTaken);
  #endif

  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    CInt96 x = CInt96(rand()) - CInt96(rand());
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for subtraction of CInt96's was %d ms\n"), dwTimeTaken);
  #endif


  //Do some speed tests on multiplication
  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    i64 x = ((i64)rand()) * ((i64)rand());
    x; //To get rid of unused variable warning
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for multiplication of __int64's was %d ms\n"), dwTimeTaken);
  #endif

  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<900000; i++)
  {
    CInt96 x = CInt96(rand()) * CInt96(rand());
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for multiplication of CInt96's was %d ms\n"), dwTimeTaken);
  #endif


  //Do some speed tests on division
  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<100000; i++)
  {
    i64 divisor = ((i64)rand());
    if (divisor)
    {
      i64 x = ((i64)rand()) / divisor;
      x; //To get rid of unused variable warning
    }
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for division of __int64's was %d ms\n"), dwTimeTaken);
  #endif

  #ifndef __GNUC__
  dwStart = GetTickCount();
  #endif
  for (i=0; i<100000; i++)
  {
    CInt96 divisor = CInt96(rand());
    if (!divisor.IsZero())
      CInt96 x = CInt96(rand()) / divisor;
  }
  #ifndef __GNUC__
  dwTimeTaken = GetTickCount() - dwStart;
  _tprintf(_T("Time taken for division of CInt96's was %d ms\n"), dwTimeTaken);
  #endif

  return (1);
}
